// Mr915ApiV20.h : main header file for the MR915API DLL
//

#define MAX_REC_NUM_NET 1024


//*******************************************//
//Mr915 define validate
//*******************************************//
#define FUCCESS_RETURN			2001  //ɹأ

#define ERR_NOTAG_RETURN		2002	//ûбǩ
#define ERR_HANDLE_VALUE		2003	//Ķ˿ھ
#define ERR_UDATA_LEN			2004	//ָݳȴ
#define ERR_UDATA_ADDRESS		2006	//ָݵַ
#define ERR_RDATA_LEN			2007	//ݳȲ
#define ERR_SDATA_FAIL			2008	//ݸʽ
#define	ERR_SCMND_FAIL			2009	//ʧ
#define ERR_READ_FAIL			2010	//ǩʧ
#define	ERR_WRITE_FAIL			2011	//дǩʧ
#define	ERR_LOCK_FAIL			2012	//ǩʧ
#define	ERR_EREASE_FAIL			2013	//ǩɾʧ
#define	ERR_PORT_OPENED			2014	//עʧ
#define	ERR_OPEN_REGSTER		2015	//˿Ѿ򿪣INVALID_HANDLE_VALUE
#define	ERR_LOAD_INI_LOST		2016	//ϢΪҵȡʧܣҪ޷ʼ
#define	ERR_DEV_INIT_FAIL		2017	//豸ʼʧ
#define	ERR_PORT_OPEN_FAIL		2018	//򿪶˿ʧ
#define	ERR_PORT_CLOSE_FAIL		2019	//رն˿ʧ
	
#define	ERR_OUT_PARA_LEN		2020	//ݳȳ
#define	ERR_GET_PARA_FAIL		2021	//ѯ豸ʧ
#define	ERR_SET_PARA_FAIL		2022	//趨豸ʧ

#define	RDERR_ GENERAL_ERR		2101	// ͳĴ
#define	RDERR_PAR_SET_FAILED	2102	// ʧ
#define	RDERR_PAR_GET_FAILED	2103	// ȡʧ
#define	RDERR_NO_TAG			2104	// ޱǩ
#define	RDERR_READ_FAILED		2105	// ǩʧ
#define	RDERR_WRITE_FAILED		2106	// ǩдʧ
#define	RDERR_LOCK_FAILED		2107	// ǩʧ
#define	RDERR_ERASE_FAILED		2108	// ǩʧ
#define	RDERR_CMD_ERR			2354	// ֻ֧Χ
#define	RDERR_UNDEFINED			2355	// δ
/////////////////////////////////////////////////////////////////////////////

#define PARAM_INDICATE		0x01	//	ʶʾ
#define PARAM_READER_ADDR	0x02	//	дַ-RS485ͨѶ

/////////////////////////////////////////////////////////////////////////////
// CMr915ApiApp
// See Mr915Api.cpp for the implementation of this class
//

class CMr915ApiApp : public CWinApp
{
public:
	CMr915ApiApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMr915ApiApp)
	public:
		virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CMr915ApiApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

typedef struct
{
	BYTE byyLabelType ;	//ǩͣ1 = ISO18000-6B,2 = ISO18000-6C/EPCǩ
	BYTE byyAntenna;		//ߺ(Զͨ)
	BYTE byyLabelID[8];		//ISO18000-6BǩID
	BYTE byyLabelEPC[12];	//ISO18000-6C/EPCǩEPC
}TAGS_CONTROL;

typedef struct
{
	BYTE TagID[8];		//ǩID
	BYTE byAddress;		//ǩַϢ
	BYTE byAntenna;		//ȡǩ
}ReadControl;

typedef struct
{
	BYTE byyAntenna;
	BYTE byLabelData[8];
}TAGDATA_CONTROL;

typedef struct
{
	BYTE TagID[8];		//ǩID
	BYTE byAddress;		//дַ
	BYTE byValue[4];		//дݣһֽ
}WriteControl;

typedef struct
{ 
	BYTE byMembank;
	BYTE byWordPtr;
	BYTE byWordCnt;
}EPC_READ_CONTROL;

typedef struct
{
	BYTE byMembank;
	BYTE byWordPtr;
	BYTE byWordCnt;
	BYTE byKillPWD[4];  //  ǩ룬4ֽڣ2
	BYTE byAccessPWD[4];//  ǩķ룬4ֽڣ2
	BYTE byLabelEPC[12];	//	ǩEPC룬6֣12ֽ
	BYTE byMemoData[16];//	ǩûֵ֧16ֽڣ8֣
}EPC_WRITE_CONTROL;

typedef struct
{
	BYTE byIpValue[4];	//IPַ
	BYTE byMarkValue[4];	//
	BYTE byGateValue[4];	//ȱʡ
	int	 m_nPort;		//˿ں
}NET_SETTING;

typedef struct
{
	BYTE byKillPWD[4];  //  ǩ룬4ֽڣ2
	BYTE byAccessPWD[4];//  ǩķ룬4ֽڣ2
	BYTE byLabelEPC[12];	//	ǩEPC룬6֣12ֽ
	BYTE byLabelTID[8];	//	ǩTID룬8ֽ
	BYTE byMemoData[16];//	ǩûֵ֧16ֽڣ8֣
}EPC_LABEL_VALUE;

typedef struct
{
	BYTE byLevel[8];	//	˿ڵƽ״̬
}INPUT_LEVEL;

#define DllExport _declspec(dllexport)

extern "C" DllExport int __stdcall ConnectReader (HANDLE &hPort, int nTransMode,int nNetPort,LPCTSTR strReaderIP,LPCTSTR strSerialNum);		//ʼ豸˿ӺREADERʵȲ

extern "C" DllExport int __stdcall Disconnect (HANDLE hPort);		//ر豸˿ڣϿ豸

extern "C" DllExport int __stdcall  SetBaudRate(HANDLE hPort, USHORT BaudRate, BYTE ReaderAddr = 0xff);		//öдĲ	

extern "C" DllExport int __stdcall  ResetReader(HANDLE hPort, BYTE ReaderAddr = 0xff);		//дλ

extern "C" DllExport int __stdcall  GetFirmwareVersion (HANDLE hPort, BYTE &major,BYTE &minor, BYTE ReaderAddr = 0xff);		//ȡд̼汾
extern "C" DllExport int __stdcall  SetRf(HANDLE hPort,BYTE byPower,BYTE byFreqType,BYTE byReaderAddr = 0xff);		//öдĹʺƵʲ
extern "C" DllExport int __stdcall  GetRf(HANDLE hPort,BYTE &byPower,BYTE &byFreqType,BYTE byReaderAddr = 0xff) ;		//ȡдĵǰƵ
extern "C" DllExport int __stdcall  GetAntenna(HANDLE hPort,BYTE &ant,BYTE byReaderAddr) ;		//öдĹʺƵʲ
extern "C" DllExport int __stdcall  SetAntenna(HANDLE hPort,BYTE byAntenna,BYTE byReaderAddr) ;		//ȡдĵǰƵ

//******************************************************//
//ISO18000-6B Tag operate function
//******************************************************//

extern "C" DllExport int __stdcall  IsoMultiTagIdentify(HANDLE hPort, BYTE byReaderAddr, short &nCount,TAGS_CONTROL *tagTags);		//ISO18000-6Bǩʶ𡣰ظݹˣµһֶǩʶǰʹClearIDBufferдڲա
extern "C" DllExport int __stdcall  IsoReadWithID(HANDLE hPort, ReadControl ReadCtrl,TAGDATA_CONTROL &tdData,BYTE byReaderAddr = 0xff);		//ȡָIDŵıǩݣÿζȡַָʼ8ֽ
extern "C" DllExport int __stdcall  IsoWriteWithID(HANDLE hPort, WriteControl WriteCtrl,BYTE byReaderAddr = 0xff);		//ָIDŵıǩд
extern "C" DllExport int __stdcall  IsoBlockWrite(HANDLE hPort, WriteControl WriteCtrl,BYTE byReaderAddr);		//ַָд4ֽݡ
extern "C" DllExport int __stdcall  IsoLockTag(HANDLE hPort ,BYTE byRomAddr, BYTE ReaderAddr);		//ָıǩַдһõַܱ
extern "C" DllExport int __stdcall  IsoQueryLock(HANDLE hPort, BYTE byRomAddr,BYTE &byIsLocked, BYTE ReaderAddr);		//ѯַָǷд

//******************************************************//
//ISO18000-6C/EPC Tag operate function
//******************************************************//

extern "C" DllExport int __stdcall  Gen2MultiTagIdentify(HANDLE hPort,BYTE byReaderAddr, short &nCount,TAGS_CONTROL *taTags);					 //EPC GEN2 ǩʶ,ظݹ
extern "C" DllExport int __stdcall  Gen2WriteEPC(HANDLE hPort,EPC_WRITE_CONTROL byWriteCtrl,BYTE byReaderAddr);									 //EPC GEN2 ǩEPCд,ÿд1֣2ֽڣ
extern "C" DllExport int __stdcall  Gen2LockTag(HANDLE hPort,BYTE byMemBank, BYTE byReaderAddr = 0xFF);											 //EPCǩдÿдһ
extern "C" DllExport int __stdcall  Gen2KillTag(HANDLE hPort ,unsigned int PassWord, BYTE byReaderAddr = 0xFF);									 //EPC GEN2ǩ
extern "C" DllExport int __stdcall  Gen2InitEPCSize(HANDLE hPort, BYTE byWordCount, BYTE byReaderAddr = 0xFF);									 //ʼǩEPCȣĬϳʼΪ96λ6ֵ֣Ϊȫ0
extern "C" DllExport int __stdcall  Gen2ReadBlock(HANDLE hPort,EPC_READ_CONTROL epcReadCtrl,EPC_LABEL_VALUE &epcValue, BYTE byReaderAddr = 0xFF);//ȡEPC ǩTID룬бǩTID
extern "C" DllExport int __stdcall  Gen2BlockWrite(HANDLE hPort ,EPC_WRITE_CONTROL epcWriteCtrl,BYTE byReaderAddr  = 0xFF);					 //EPC GEN2 ǩд

//******************************************************//
//MR915 System command operate function
//******************************************************//

extern "C" DllExport int __stdcall  ClearIDBuffer(HANDLE hPort,BYTE byReaderAddr);								//նдǩݻÿζǩʶǰʹ
extern "C" DllExport int __stdcall  QueryIDCount(HANDLE hPort,BYTE &byCount,BYTE byReaderAddr);					//ѯбǩ

extern "C" DllExport int __stdcall  GetInput(HANDLE hPort,INPUT_LEVEL &inValue,BYTE byReaderAddr);						//ѯIO˿ڵĵƽ״̬
extern "C" DllExport int __stdcall  SetOutPort(HANDLE hPort,BYTE byPortNum,BYTE byLevel,BYTE byReaderAddr);		//IO˿ڵĸߵ͵ƽ

extern "C" DllExport int __stdcall  GetNetSetting(HANDLE hPort,NET_SETTING &nsNetSetting,BYTE byReaderAddr);	//ѯдIPַ롢ȱʡز
extern "C" DllExport int __stdcall  SetNetSetting(HANDLE hPort,NET_SETTING nsNetSetting,BYTE byReaderAddr);		//öдIPַ롢ȱʡز

extern "C" DllExport int __stdcall  GetParameter(HANDLE hPort,BYTE byType,BYTE &byValue,BYTE byReaderAddr);	//ѯдIPַ롢ȱʡز
extern "C" DllExport int __stdcall  SetParameter(HANDLE hPort,BYTE byType,BYTE byValue,BYTE byReaderAddr);		//öдIPַ롢ȱʡز
/////////////////////////////////////////////////////////////////////////////